Page MenuHomePhabricator

Provide basic suggestions based on featured articles
Closed, ResolvedPublic1 Story Points

Description

Provide an initial version of suggestions for users to have ideas on what to translate.
Some aspects that we need to consider:

  • Initial "from" and "to" languages. Especially for first time users we may not have previous language choices info. We can start by a simply using the current wiki language as target language and make a best chance choice based on our stats for source (e.g., English if it is not the target).
  • "From" and "to" selectors need adjustments. For the suggestions view, the language selection should allow to select any language. For the other views (e.g., in progress) it makes sense to show only the options of the current elements in the list, as it is done right now.
  • Showing featured articles. Recommendations will be based on feature articles missing in the target language.
  • Check that suggestions are yet to be translated. Don't display suggestions for articles that are being translated or they have been already published.
  • Instrumentation. This should be measured as an entry point in the same way we do for other campaigns.
  • Suggestions allow to start translating. When clicking a suggestion the new translation dialog will be opened with all the information pre-filled. If the translation is started, the suggestion will be removed for the list (and the translation will be shown in the "in progress" section).

Design notes

The designs are a basic version of T87439, but without the mechanism to mark suggestions for later ("star") T111026 or discard suggestions ("X") T111027, which will be added in upcoming tasks

Related Objects

Event Timeline

Pginer-WMF raised the priority of this task from to Normal.
Pginer-WMF updated the task description. (Show Details)
Pginer-WMF added a project: ContentTranslation.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJul 21 2015, 7:25 PM
Pginer-WMF updated the task description. (Show Details)Jul 21 2015, 7:29 PM
Pginer-WMF set Security to None.
Pginer-WMF updated the task description. (Show Details)Jul 21 2015, 7:32 PM
Arrbee added a subscriber: Arrbee.
Pginer-WMF edited a custom field.Jul 21 2015, 7:53 PM
Amire80 moved this task from Needs Triage to CX6 on the ContentTranslation board.Jul 28 2015, 6:34 PM
santhosh claimed this task.Aug 4 2015, 11:33 AM
santhosh moved this task from Backlog to In Progress on the LE-CX6-Sprint 1 board.

@Pginer-WMF: are you recommending the removal of "star" and "X" to make the first implementation of the dashboard more manageable or is there some other reason for it?

@Pginer-WMF: are you recommending the removal of "star" and "X" to make the first implementation of the dashboard more manageable or is there some other reason for it?

It is just to break the feature in minimal atomic parts for it to be developed iteratively. The "star" and "X" are expected to come right after this one. I'll clarify that in the description.

Pginer-WMF updated the task description. (Show Details)Aug 4 2015, 4:24 PM
leila added a comment.Aug 4 2015, 4:30 PM

Makes sense. Thanks @Pginer-WMF.

Arrbee raised the priority of this task from Normal to High.Aug 12 2015, 7:10 AM
Arrbee lowered the priority of this task from High to Normal.
Arrbee moved this task from Backlog to In Progress on the LE-CX6-Sprint 2 board.

Change 231253 had a related patch set uploaded (by Santhosh):
Suggestion lists - Database and APIs

https://gerrit.wikimedia.org/r/231253

Change 232019 had a related patch set uploaded (by Santhosh):
Dashboard: Show translation suggestions

https://gerrit.wikimedia.org/r/232019

Screenshots based on the patch:

This looks really great. I still have to check this live, but from the screenshots I have some initial comments:

  • Language filter behaviour. In the first screenshot I see the language selector being "any language > any language" if that represents suggestions across any possible languages (e.g, Chinese to Greek, Hindi to Estonian, etc.), it will be generating suggestions which are of little use for most users. I'd expect that users can select different "from" and "to" languages and provide them a smart initial default (e.g., a user accessing CX through Spanish Wikipedia would get "English > Spanish" suggestions and they can change the source language to "French" if they want to ideas for a French-to-Spanish translation). It may be also useful to provide suggestions for all the languages the user speaks and only those (based on the ones the user has already published articles in). So we may want to provide a "all your languages > all your languages" option, which may not be available for new users without any former translation.
  • The Empty state message. We can convey that the lack of suggestions is temporary, and encourage users to start a translation on their own. Proposed text: "Sorry, no suggestions for now. You can pick any topic of your choice when starting a new translation."
leila added a comment.Aug 24 2015, 6:29 PM

This looks really great. I still have to check this live, but from the screenshots I have some initial comments:

  • Language filter behaviour. In the first screenshot I see the language selector being "any language > any language" if that represents suggestions across any possible languages (e.g, Chinese to Greek, Hindi to Estonian, etc.), it will be generating suggestions which are of little use for most users. I'd expect that users can select different "from" and "to" languages and provide them a smart initial default (e.g., a user accessing CX through Spanish Wikipedia would get "English > Spanish" suggestions and they can change the source language to "French" if they want to ideas for a French-to-Spanish translation). It may be also useful to provide suggestions for all the languages the user speaks and only those (based on the ones the user has already published articles in). So we may want to provide a "all your languages > all your languages" option, which may not be available for new users without any former translation.

You may also want to consider offering Featured article recommendations in only some popular language pairs. This way, you can test the value of such recommendations, without having to worry about a viable set of language pairs from the possible 60K+ pairs you can consider. The reasoning here is that 1) you want to test now, 2) later you want to have more advanced recommendations that won't necessarily recommend any featured article to be translated to all languages (we have the algorithm :).

  • The Empty state message. We can convey that the lack of suggestions is temporary, and encourage users to start a translation on their own. Proposed text: "Sorry, no suggestions for now. You can pick any topic of your choice when starting a new translation."

Right. I also want to add that it would be good to consider adding a statement about the research app and tell the users that we're working on bringing more advanced recommendations to CX, and they can experiment with some of the work we are doing in specific language pairs here: http://recommend.wmflabs.org/#Recommend (Note: we're working on the tool and it will be ready for wider use in couple of weeks. I'm just pasting it here for you to get a sense where we are with it. :)

Arrbee moved this task from Backlog to In Review on the LE-CX6-Sprint 3 board.Aug 26 2015, 11:57 AM

Change 231253 merged by jenkins-bot:
Suggestion lists - Database and APIs

https://gerrit.wikimedia.org/r/231253

Pginer-WMF updated the task description. (Show Details)Sep 1 2015, 1:00 PM

After fixing the language selector and adding tags('featured' )
The source language label is a link pointing to source article. It also has a tool tip-view source article.

After fixing the language selector and adding tags('featured' )
The source language label is a link pointing to source article. It also has a tool tip-view source article.

This is awesome. I have a couple of comments about adjusting the prominence of some elements:

  • Feature label. Since our initial algorithm only selects featured articles we can use a less prominent style temporally (e.g., green text with no background). That will highlight that the articles are featured but not too much (since all of them are).
  • New translation button. Currently it is competing with the suggestions and disconnected from it. It would be better to connect the button with the list (for all views) and make it quiet-constructive for the suggestions view. More details at T104567.
Arrbee moved this task from Backlog to In Progress on the LE-CX6-Sprint 4 board.Sep 9 2015, 6:40 AM
Arrbee moved this task from In Progress to In Review on the LE-CX6-Sprint 4 board.

Change 232019 merged by jenkins-bot:
Dashboard: Show translation suggestions

https://gerrit.wikimedia.org/r/232019

  • Initial "from" and "to" languages. Especially for first time users we may not have previous language choices info. We can start by a simply using the current wiki language as target language and make a best chance choice based on our stats for source (e.g., English if it is not the target).
  • "From" and "to" selectors need adjustments. For the suggestions view, the language selection should allow to select any language. For the other views (e.g., in progress) it makes sense to show only the options of the current elements in the list, as it is done right now.

As part of the initial implementation, language selection aspects were not considered. They have been moved to a separate ticket: T112051: Support language selection for suggestions

Pginer-WMF added a comment.EditedSep 10 2015, 5:58 PM

I tried the suggestions locally and works quite well. Some small comments:

  • The whole suggestion element should be clickable to start a new suggestion, not only the title. Having the whole element interactive makes it easy to start translating and makes it consistent with (a) the highlight on hover, and (b) the items on other lists such as on-going translations.
  • When opening the dialog from a suggestion, the focus should be in the target title field. Currently, if I select suggestion A, the new translation dialog opens with the text cursor in the source field (which results on the autocompletion article list to be displayed). Since it is unlikely that the user will change the article to translate right after selecting the suggestion, it is better to move to the input to the next field. (Moved to T113332)
  • When the header becomes sticky there are some layout glitches. Suggestions can be a long list. When users scroll, the header becomes sticky to the top. However the change in the display mode results in (a) a jump in the content (we used an additional top padding to compensate for the elements that become "fixed" positioned), and (b) the language selector expands with no margin around it. (Moved to T113333)
  • Smaller styling details: On suggestion items, languages and the "feature" label are not aligned (i.e., sitting on the same baseline). When making the window small, the items in the list break in multiple lines while there is room for them.The padding and size of the language selector needs also some adjustment.

Feel free to split into separate tasks if they are not quick fixes worth taking as part of the review process of this one.

Pginer-WMF added a comment.EditedSep 11 2015, 11:35 AM

A couple more comments about the dashboard initial status:

  • Currently when reaching the dashboard without existing translations, some items are missing: language selector labels and the empty state message (see mockup below). After switching the views, the empty state message becomes visible but it is not initially.
  • When landing Content Translation, if (and only if) the list of ongoing translations is empty and there are suggestions, the initial view should be the suggestions view. That will provide the user ideas on what to translate next if there is no pending work to be done (in which case the in-progress view should be the default). (Moved to T113334)

Change 238094 had a related patch set uploaded (by Santhosh):
Suggestions: Fix the featured lable alignment error

https://gerrit.wikimedia.org/r/238094

On suggestion items, languages and the "feature" label are not aligned

After https://gerrit.wikimedia.org/r/238094 fix

Change 238107 had a related patch set uploaded (by Santhosh):
Suggestions: Make the whole suggestion item clickable

https://gerrit.wikimedia.org/r/238107

The whole suggestion element should be clickable to start a new suggestion, not only the title

Fixed in: Suggestions: Make the whole suggestion item clickable https://gerrit.wikimedia.org/r/238107

Change 238107 merged by jenkins-bot:
Suggestions: Make the whole suggestion item clickable

https://gerrit.wikimedia.org/r/238107

Change 238094 merged by jenkins-bot:
Suggestions: Fix the featured label alignment error

https://gerrit.wikimedia.org/r/238094

Arrbee moved this task from In Review to QA on the LE-CX6-Sprint 4 board.Sep 17 2015, 8:11 AM
Arrbee moved this task from QA to Done on the LE-CX6-Sprint 4 board.Sep 18 2015, 7:09 AM

Arrbee moved this task to Done on the LE-CX6-Sprint 4 workboard.

Please, before closing make sure to check my comments above and move those that still apply to new tickets.

KartikMistry moved this task from QA to Done on the LE-CX7-Sprint 1 board.Oct 15 2015, 5:42 AM
Amire80 closed this task as Resolved.Oct 21 2015, 6:15 AM
Amire80 added a subscriber: Amire80.

Resolving this. As far as I can see, the follow-ups are reported separately.